/**
 */
package de.uks.se.scenariodiagram;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Scenario Link</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.uks.se.scenariodiagram.ScenarioLink#getOutgoingReference <em>Outgoing Reference</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.ScenarioLink#getIncomingReference <em>Incoming Reference</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.ScenarioLink#getAttributes <em>Attributes</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.ScenarioLink#getParent <em>Parent</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.ScenarioLink#getSource <em>Source</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.ScenarioLink#getTarget <em>Target</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.uks.se.scenariodiagram.ScenariodiagramPackage#getScenarioLink()
 * @model
 * @generated
 */
public interface ScenarioLink extends EObject
{
  /**
   * Returns the value of the '<em><b>Outgoing Reference</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Outgoing Reference</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Outgoing Reference</em>' reference.
   * @see #setOutgoingReference(EReference)
   * @see de.uks.se.scenariodiagram.ScenariodiagramPackage#getScenarioLink_OutgoingReference()
   * @model
   * @generated
   */
  EReference getOutgoingReference();

  /**
   * Sets the value of the '{@link de.uks.se.scenariodiagram.ScenarioLink#getOutgoingReference <em>Outgoing Reference</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Outgoing Reference</em>' reference.
   * @see #getOutgoingReference()
   * @generated
   */
  void setOutgoingReference(EReference value);

  /**
   * Returns the value of the '<em><b>Incoming Reference</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Incoming Reference</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Incoming Reference</em>' reference.
   * @see #setIncomingReference(EReference)
   * @see de.uks.se.scenariodiagram.ScenariodiagramPackage#getScenarioLink_IncomingReference()
   * @model
   * @generated
   */
  EReference getIncomingReference();

  /**
   * Sets the value of the '{@link de.uks.se.scenariodiagram.ScenarioLink#getIncomingReference <em>Incoming Reference</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Incoming Reference</em>' reference.
   * @see #getIncomingReference()
   * @generated
   */
  void setIncomingReference(EReference value);

  /**
   * Returns the value of the '<em><b>Attributes</b></em>' containment reference list.
   * The list contents are of type {@link de.uks.se.scenariodiagram.ScenarioAttribute}.
   * It is bidirectional and its opposite is '{@link de.uks.se.scenariodiagram.ScenarioAttribute#getLink <em>Link</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Attributes</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Attributes</em>' containment reference list.
   * @see de.uks.se.scenariodiagram.ScenariodiagramPackage#getScenarioLink_Attributes()
   * @see de.uks.se.scenariodiagram.ScenarioAttribute#getLink
   * @model opposite="link" containment="true"
   * @generated
   */
  EList<ScenarioAttribute> getAttributes();

  /**
   * Returns the value of the '<em><b>Parent</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link de.uks.se.scenariodiagram.ScenarioObject#getLinks <em>Links</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Parent</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Parent</em>' container reference.
   * @see #setParent(ScenarioObject)
   * @see de.uks.se.scenariodiagram.ScenariodiagramPackage#getScenarioLink_Parent()
   * @see de.uks.se.scenariodiagram.ScenarioObject#getLinks
   * @model opposite="links" transient="false"
   * @generated
   */
  ScenarioObject getParent();

  /**
   * Sets the value of the '{@link de.uks.se.scenariodiagram.ScenarioLink#getParent <em>Parent</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Parent</em>' container reference.
   * @see #getParent()
   * @generated
   */
  void setParent(ScenarioObject value);

  /**
   * Returns the value of the '<em><b>Source</b></em>' reference.
   * It is bidirectional and its opposite is '{@link de.uks.se.scenariodiagram.ScenarioObject#getOutgoingLinks <em>Outgoing Links</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Source</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Source</em>' reference.
   * @see #setSource(ScenarioObject)
   * @see de.uks.se.scenariodiagram.ScenariodiagramPackage#getScenarioLink_Source()
   * @see de.uks.se.scenariodiagram.ScenarioObject#getOutgoingLinks
   * @model opposite="outgoingLinks"
   * @generated
   */
  ScenarioObject getSource();

  /**
   * Sets the value of the '{@link de.uks.se.scenariodiagram.ScenarioLink#getSource <em>Source</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Source</em>' reference.
   * @see #getSource()
   * @generated
   */
  void setSource(ScenarioObject value);

  /**
   * Returns the value of the '<em><b>Target</b></em>' reference.
   * It is bidirectional and its opposite is '{@link de.uks.se.scenariodiagram.ScenarioObject#getIncomingLinks <em>Incoming Links</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target</em>' reference.
   * @see #setTarget(ScenarioObject)
   * @see de.uks.se.scenariodiagram.ScenariodiagramPackage#getScenarioLink_Target()
   * @see de.uks.se.scenariodiagram.ScenarioObject#getIncomingLinks
   * @model opposite="incomingLinks"
   * @generated
   */
  ScenarioObject getTarget();

  /**
   * Sets the value of the '{@link de.uks.se.scenariodiagram.ScenarioLink#getTarget <em>Target</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target</em>' reference.
   * @see #getTarget()
   * @generated
   */
  void setTarget(ScenarioObject value);

} // ScenarioLink
