/**
 */
package de.uks.se.scenariodiagram;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Scenario Object</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.uks.se.scenariodiagram.ScenarioObject#getObjectType <em>Object Type</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.ScenarioObject#getParentDiagram <em>Parent Diagram</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.ScenarioObject#getContainedScenarioObjects <em>Contained Scenario Objects</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.ScenarioObject#getParent <em>Parent</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.ScenarioObject#getAttributes <em>Attributes</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.ScenarioObject#getLinks <em>Links</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.ScenarioObject#getOutgoingLinks <em>Outgoing Links</em>}</li>
 *   <li>{@link de.uks.se.scenariodiagram.ScenarioObject#getIncomingLinks <em>Incoming Links</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.uks.se.scenariodiagram.ScenariodiagramPackage#getScenarioObject()
 * @model
 * @generated
 */
public interface ScenarioObject extends EObject
{
  /**
   * Returns the value of the '<em><b>Object Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Object Type</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Object Type</em>' reference.
   * @see #setObjectType(EClass)
   * @see de.uks.se.scenariodiagram.ScenariodiagramPackage#getScenarioObject_ObjectType()
   * @model
   * @generated
   */
  EClass getObjectType();

  /**
   * Sets the value of the '{@link de.uks.se.scenariodiagram.ScenarioObject#getObjectType <em>Object Type</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Object Type</em>' reference.
   * @see #getObjectType()
   * @generated
   */
  void setObjectType(EClass value);

  /**
   * Returns the value of the '<em><b>Parent Diagram</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link de.uks.se.scenariodiagram.ScenarioDiagram#getContainedScenarioObjects <em>Contained Scenario Objects</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Parent Diagram</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Parent Diagram</em>' container reference.
   * @see #setParentDiagram(ScenarioDiagram)
   * @see de.uks.se.scenariodiagram.ScenariodiagramPackage#getScenarioObject_ParentDiagram()
   * @see de.uks.se.scenariodiagram.ScenarioDiagram#getContainedScenarioObjects
   * @model opposite="containedScenarioObjects" transient="false"
   * @generated
   */
  ScenarioDiagram getParentDiagram();

  /**
   * Sets the value of the '{@link de.uks.se.scenariodiagram.ScenarioObject#getParentDiagram <em>Parent Diagram</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Parent Diagram</em>' container reference.
   * @see #getParentDiagram()
   * @generated
   */
  void setParentDiagram(ScenarioDiagram value);

  /**
   * Returns the value of the '<em><b>Contained Scenario Objects</b></em>' containment reference list.
   * The list contents are of type {@link de.uks.se.scenariodiagram.ScenarioObject}.
   * It is bidirectional and its opposite is '{@link de.uks.se.scenariodiagram.ScenarioObject#getParent <em>Parent</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Contained Scenario Objects</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Contained Scenario Objects</em>' containment reference list.
   * @see de.uks.se.scenariodiagram.ScenariodiagramPackage#getScenarioObject_ContainedScenarioObjects()
   * @see de.uks.se.scenariodiagram.ScenarioObject#getParent
   * @model opposite="parent" containment="true"
   * @generated
   */
  EList<ScenarioObject> getContainedScenarioObjects();

  /**
   * Returns the value of the '<em><b>Parent</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link de.uks.se.scenariodiagram.ScenarioObject#getContainedScenarioObjects <em>Contained Scenario Objects</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Parent</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Parent</em>' container reference.
   * @see #setParent(ScenarioObject)
   * @see de.uks.se.scenariodiagram.ScenariodiagramPackage#getScenarioObject_Parent()
   * @see de.uks.se.scenariodiagram.ScenarioObject#getContainedScenarioObjects
   * @model opposite="containedScenarioObjects" transient="false"
   * @generated
   */
  ScenarioObject getParent();

  /**
   * Sets the value of the '{@link de.uks.se.scenariodiagram.ScenarioObject#getParent <em>Parent</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Parent</em>' container reference.
   * @see #getParent()
   * @generated
   */
  void setParent(ScenarioObject value);

  /**
   * Returns the value of the '<em><b>Attributes</b></em>' containment reference list.
   * The list contents are of type {@link de.uks.se.scenariodiagram.ScenarioAttribute}.
   * It is bidirectional and its opposite is '{@link de.uks.se.scenariodiagram.ScenarioAttribute#getObject <em>Object</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Attributes</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Attributes</em>' containment reference list.
   * @see de.uks.se.scenariodiagram.ScenariodiagramPackage#getScenarioObject_Attributes()
   * @see de.uks.se.scenariodiagram.ScenarioAttribute#getObject
   * @model opposite="object" containment="true"
   * @generated
   */
  EList<ScenarioAttribute> getAttributes();

  /**
   * Returns the value of the '<em><b>Links</b></em>' containment reference list.
   * The list contents are of type {@link de.uks.se.scenariodiagram.ScenarioLink}.
   * It is bidirectional and its opposite is '{@link de.uks.se.scenariodiagram.ScenarioLink#getParent <em>Parent</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Links</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Links</em>' containment reference list.
   * @see de.uks.se.scenariodiagram.ScenariodiagramPackage#getScenarioObject_Links()
   * @see de.uks.se.scenariodiagram.ScenarioLink#getParent
   * @model opposite="parent" containment="true"
   * @generated
   */
  EList<ScenarioLink> getLinks();

  /**
   * Returns the value of the '<em><b>Outgoing Links</b></em>' reference list.
   * The list contents are of type {@link de.uks.se.scenariodiagram.ScenarioLink}.
   * It is bidirectional and its opposite is '{@link de.uks.se.scenariodiagram.ScenarioLink#getSource <em>Source</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Outgoing Links</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Outgoing Links</em>' reference list.
   * @see de.uks.se.scenariodiagram.ScenariodiagramPackage#getScenarioObject_OutgoingLinks()
   * @see de.uks.se.scenariodiagram.ScenarioLink#getSource
   * @model opposite="source"
   * @generated
   */
  EList<ScenarioLink> getOutgoingLinks();

  /**
   * Returns the value of the '<em><b>Incoming Links</b></em>' reference list.
   * The list contents are of type {@link de.uks.se.scenariodiagram.ScenarioLink}.
   * It is bidirectional and its opposite is '{@link de.uks.se.scenariodiagram.ScenarioLink#getTarget <em>Target</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Incoming Links</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Incoming Links</em>' reference list.
   * @see de.uks.se.scenariodiagram.ScenariodiagramPackage#getScenarioObject_IncomingLinks()
   * @see de.uks.se.scenariodiagram.ScenarioLink#getTarget
   * @model opposite="target"
   * @generated
   */
  EList<ScenarioLink> getIncomingLinks();

} // ScenarioObject
