/**
 */
package de.uks.se.scenariodiagram;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see de.uks.se.scenariodiagram.ScenariodiagramFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/emf/2002/GenModel editDirectory='/ScenarioDiagramModel/src-edit' editorDirectory='/ScenarioDiagramModel/src-editor' testsDirectory='/ScenarioDiagramModel/src-tests' basePackage='de.uks.se'"
 * @generated
 */
public interface ScenariodiagramPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "scenariodiagram";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "de.uks.se.scenariodiagram";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "scenariodiagram";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  ScenariodiagramPackage eINSTANCE = de.uks.se.scenariodiagram.impl.ScenariodiagramPackageImpl.init();

  /**
   * The meta object id for the '{@link de.uks.se.scenariodiagram.impl.ScenarioDiagramImpl <em>Scenario Diagram</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see de.uks.se.scenariodiagram.impl.ScenarioDiagramImpl
   * @see de.uks.se.scenariodiagram.impl.ScenariodiagramPackageImpl#getScenarioDiagram()
   * @generated
   */
  int SCENARIO_DIAGRAM = 0;

  /**
   * The feature id for the '<em><b>Contained Scenario Objects</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_DIAGRAM__CONTAINED_SCENARIO_OBJECTS = 0;

  /**
   * The feature id for the '<em><b>Object Types</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_DIAGRAM__OBJECT_TYPES = 1;

  /**
   * The number of structural features of the '<em>Scenario Diagram</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_DIAGRAM_FEATURE_COUNT = 2;

  /**
   * The number of operations of the '<em>Scenario Diagram</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_DIAGRAM_OPERATION_COUNT = 0;

  /**
   * The meta object id for the '{@link de.uks.se.scenariodiagram.impl.ScenarioObjectImpl <em>Scenario Object</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see de.uks.se.scenariodiagram.impl.ScenarioObjectImpl
   * @see de.uks.se.scenariodiagram.impl.ScenariodiagramPackageImpl#getScenarioObject()
   * @generated
   */
  int SCENARIO_OBJECT = 1;

  /**
   * The feature id for the '<em><b>Object Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_OBJECT__OBJECT_TYPE = 0;

  /**
   * The feature id for the '<em><b>Parent Diagram</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_OBJECT__PARENT_DIAGRAM = 1;

  /**
   * The feature id for the '<em><b>Contained Scenario Objects</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_OBJECT__CONTAINED_SCENARIO_OBJECTS = 2;

  /**
   * The feature id for the '<em><b>Parent</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_OBJECT__PARENT = 3;

  /**
   * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_OBJECT__ATTRIBUTES = 4;

  /**
   * The feature id for the '<em><b>Links</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_OBJECT__LINKS = 5;

  /**
   * The feature id for the '<em><b>Outgoing Links</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_OBJECT__OUTGOING_LINKS = 6;

  /**
   * The feature id for the '<em><b>Incoming Links</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_OBJECT__INCOMING_LINKS = 7;

  /**
   * The number of structural features of the '<em>Scenario Object</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_OBJECT_FEATURE_COUNT = 8;

  /**
   * The number of operations of the '<em>Scenario Object</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_OBJECT_OPERATION_COUNT = 0;

  /**
   * The meta object id for the '{@link de.uks.se.scenariodiagram.impl.ScenarioAttributeImpl <em>Scenario Attribute</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see de.uks.se.scenariodiagram.impl.ScenarioAttributeImpl
   * @see de.uks.se.scenariodiagram.impl.ScenariodiagramPackageImpl#getScenarioAttribute()
   * @generated
   */
  int SCENARIO_ATTRIBUTE = 2;

  /**
   * The feature id for the '<em><b>Attribute Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_ATTRIBUTE__ATTRIBUTE_TYPE = 0;

  /**
   * The feature id for the '<em><b>Object</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_ATTRIBUTE__OBJECT = 1;

  /**
   * The feature id for the '<em><b>Link</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_ATTRIBUTE__LINK = 2;

  /**
   * The feature id for the '<em><b>Tag</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_ATTRIBUTE__TAG = 3;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_ATTRIBUTE__VALUE = 4;

  /**
   * The number of structural features of the '<em>Scenario Attribute</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_ATTRIBUTE_FEATURE_COUNT = 5;

  /**
   * The number of operations of the '<em>Scenario Attribute</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_ATTRIBUTE_OPERATION_COUNT = 0;

  /**
   * The meta object id for the '{@link de.uks.se.scenariodiagram.impl.ScenarioLinkImpl <em>Scenario Link</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see de.uks.se.scenariodiagram.impl.ScenarioLinkImpl
   * @see de.uks.se.scenariodiagram.impl.ScenariodiagramPackageImpl#getScenarioLink()
   * @generated
   */
  int SCENARIO_LINK = 3;

  /**
   * The feature id for the '<em><b>Outgoing Reference</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_LINK__OUTGOING_REFERENCE = 0;

  /**
   * The feature id for the '<em><b>Incoming Reference</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_LINK__INCOMING_REFERENCE = 1;

  /**
   * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_LINK__ATTRIBUTES = 2;

  /**
   * The feature id for the '<em><b>Parent</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_LINK__PARENT = 3;

  /**
   * The feature id for the '<em><b>Source</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_LINK__SOURCE = 4;

  /**
   * The feature id for the '<em><b>Target</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_LINK__TARGET = 5;

  /**
   * The number of structural features of the '<em>Scenario Link</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_LINK_FEATURE_COUNT = 6;

  /**
   * The number of operations of the '<em>Scenario Link</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCENARIO_LINK_OPERATION_COUNT = 0;


  /**
   * Returns the meta object for class '{@link de.uks.se.scenariodiagram.ScenarioDiagram <em>Scenario Diagram</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Scenario Diagram</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioDiagram
   * @generated
   */
  EClass getScenarioDiagram();

  /**
   * Returns the meta object for the containment reference list '{@link de.uks.se.scenariodiagram.ScenarioDiagram#getContainedScenarioObjects <em>Contained Scenario Objects</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Contained Scenario Objects</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioDiagram#getContainedScenarioObjects()
   * @see #getScenarioDiagram()
   * @generated
   */
  EReference getScenarioDiagram_ContainedScenarioObjects();

  /**
   * Returns the meta object for the containment reference list '{@link de.uks.se.scenariodiagram.ScenarioDiagram#getObjectTypes <em>Object Types</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Object Types</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioDiagram#getObjectTypes()
   * @see #getScenarioDiagram()
   * @generated
   */
  EReference getScenarioDiagram_ObjectTypes();

  /**
   * Returns the meta object for class '{@link de.uks.se.scenariodiagram.ScenarioObject <em>Scenario Object</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Scenario Object</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioObject
   * @generated
   */
  EClass getScenarioObject();

  /**
   * Returns the meta object for the reference '{@link de.uks.se.scenariodiagram.ScenarioObject#getObjectType <em>Object Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Object Type</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioObject#getObjectType()
   * @see #getScenarioObject()
   * @generated
   */
  EReference getScenarioObject_ObjectType();

  /**
   * Returns the meta object for the container reference '{@link de.uks.se.scenariodiagram.ScenarioObject#getParentDiagram <em>Parent Diagram</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Parent Diagram</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioObject#getParentDiagram()
   * @see #getScenarioObject()
   * @generated
   */
  EReference getScenarioObject_ParentDiagram();

  /**
   * Returns the meta object for the containment reference list '{@link de.uks.se.scenariodiagram.ScenarioObject#getContainedScenarioObjects <em>Contained Scenario Objects</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Contained Scenario Objects</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioObject#getContainedScenarioObjects()
   * @see #getScenarioObject()
   * @generated
   */
  EReference getScenarioObject_ContainedScenarioObjects();

  /**
   * Returns the meta object for the container reference '{@link de.uks.se.scenariodiagram.ScenarioObject#getParent <em>Parent</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Parent</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioObject#getParent()
   * @see #getScenarioObject()
   * @generated
   */
  EReference getScenarioObject_Parent();

  /**
   * Returns the meta object for the containment reference list '{@link de.uks.se.scenariodiagram.ScenarioObject#getAttributes <em>Attributes</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Attributes</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioObject#getAttributes()
   * @see #getScenarioObject()
   * @generated
   */
  EReference getScenarioObject_Attributes();

  /**
   * Returns the meta object for the containment reference list '{@link de.uks.se.scenariodiagram.ScenarioObject#getLinks <em>Links</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Links</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioObject#getLinks()
   * @see #getScenarioObject()
   * @generated
   */
  EReference getScenarioObject_Links();

  /**
   * Returns the meta object for the reference list '{@link de.uks.se.scenariodiagram.ScenarioObject#getOutgoingLinks <em>Outgoing Links</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Outgoing Links</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioObject#getOutgoingLinks()
   * @see #getScenarioObject()
   * @generated
   */
  EReference getScenarioObject_OutgoingLinks();

  /**
   * Returns the meta object for the reference list '{@link de.uks.se.scenariodiagram.ScenarioObject#getIncomingLinks <em>Incoming Links</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Incoming Links</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioObject#getIncomingLinks()
   * @see #getScenarioObject()
   * @generated
   */
  EReference getScenarioObject_IncomingLinks();

  /**
   * Returns the meta object for class '{@link de.uks.se.scenariodiagram.ScenarioAttribute <em>Scenario Attribute</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Scenario Attribute</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioAttribute
   * @generated
   */
  EClass getScenarioAttribute();

  /**
   * Returns the meta object for the reference '{@link de.uks.se.scenariodiagram.ScenarioAttribute#getAttributeType <em>Attribute Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Attribute Type</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioAttribute#getAttributeType()
   * @see #getScenarioAttribute()
   * @generated
   */
  EReference getScenarioAttribute_AttributeType();

  /**
   * Returns the meta object for the container reference '{@link de.uks.se.scenariodiagram.ScenarioAttribute#getObject <em>Object</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Object</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioAttribute#getObject()
   * @see #getScenarioAttribute()
   * @generated
   */
  EReference getScenarioAttribute_Object();

  /**
   * Returns the meta object for the container reference '{@link de.uks.se.scenariodiagram.ScenarioAttribute#getLink <em>Link</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Link</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioAttribute#getLink()
   * @see #getScenarioAttribute()
   * @generated
   */
  EReference getScenarioAttribute_Link();

  /**
   * Returns the meta object for the attribute '{@link de.uks.se.scenariodiagram.ScenarioAttribute#getTag <em>Tag</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Tag</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioAttribute#getTag()
   * @see #getScenarioAttribute()
   * @generated
   */
  EAttribute getScenarioAttribute_Tag();

  /**
   * Returns the meta object for the attribute '{@link de.uks.se.scenariodiagram.ScenarioAttribute#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioAttribute#getValue()
   * @see #getScenarioAttribute()
   * @generated
   */
  EAttribute getScenarioAttribute_Value();

  /**
   * Returns the meta object for class '{@link de.uks.se.scenariodiagram.ScenarioLink <em>Scenario Link</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Scenario Link</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioLink
   * @generated
   */
  EClass getScenarioLink();

  /**
   * Returns the meta object for the reference '{@link de.uks.se.scenariodiagram.ScenarioLink#getOutgoingReference <em>Outgoing Reference</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Outgoing Reference</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioLink#getOutgoingReference()
   * @see #getScenarioLink()
   * @generated
   */
  EReference getScenarioLink_OutgoingReference();

  /**
   * Returns the meta object for the reference '{@link de.uks.se.scenariodiagram.ScenarioLink#getIncomingReference <em>Incoming Reference</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Incoming Reference</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioLink#getIncomingReference()
   * @see #getScenarioLink()
   * @generated
   */
  EReference getScenarioLink_IncomingReference();

  /**
   * Returns the meta object for the containment reference list '{@link de.uks.se.scenariodiagram.ScenarioLink#getAttributes <em>Attributes</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Attributes</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioLink#getAttributes()
   * @see #getScenarioLink()
   * @generated
   */
  EReference getScenarioLink_Attributes();

  /**
   * Returns the meta object for the container reference '{@link de.uks.se.scenariodiagram.ScenarioLink#getParent <em>Parent</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Parent</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioLink#getParent()
   * @see #getScenarioLink()
   * @generated
   */
  EReference getScenarioLink_Parent();

  /**
   * Returns the meta object for the reference '{@link de.uks.se.scenariodiagram.ScenarioLink#getSource <em>Source</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Source</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioLink#getSource()
   * @see #getScenarioLink()
   * @generated
   */
  EReference getScenarioLink_Source();

  /**
   * Returns the meta object for the reference '{@link de.uks.se.scenariodiagram.ScenarioLink#getTarget <em>Target</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Target</em>'.
   * @see de.uks.se.scenariodiagram.ScenarioLink#getTarget()
   * @see #getScenarioLink()
   * @generated
   */
  EReference getScenarioLink_Target();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  ScenariodiagramFactory getScenariodiagramFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each operation of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link de.uks.se.scenariodiagram.impl.ScenarioDiagramImpl <em>Scenario Diagram</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see de.uks.se.scenariodiagram.impl.ScenarioDiagramImpl
     * @see de.uks.se.scenariodiagram.impl.ScenariodiagramPackageImpl#getScenarioDiagram()
     * @generated
     */
    EClass SCENARIO_DIAGRAM = eINSTANCE.getScenarioDiagram();

    /**
     * The meta object literal for the '<em><b>Contained Scenario Objects</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_DIAGRAM__CONTAINED_SCENARIO_OBJECTS = eINSTANCE.getScenarioDiagram_ContainedScenarioObjects();

    /**
     * The meta object literal for the '<em><b>Object Types</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_DIAGRAM__OBJECT_TYPES = eINSTANCE.getScenarioDiagram_ObjectTypes();

    /**
     * The meta object literal for the '{@link de.uks.se.scenariodiagram.impl.ScenarioObjectImpl <em>Scenario Object</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see de.uks.se.scenariodiagram.impl.ScenarioObjectImpl
     * @see de.uks.se.scenariodiagram.impl.ScenariodiagramPackageImpl#getScenarioObject()
     * @generated
     */
    EClass SCENARIO_OBJECT = eINSTANCE.getScenarioObject();

    /**
     * The meta object literal for the '<em><b>Object Type</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_OBJECT__OBJECT_TYPE = eINSTANCE.getScenarioObject_ObjectType();

    /**
     * The meta object literal for the '<em><b>Parent Diagram</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_OBJECT__PARENT_DIAGRAM = eINSTANCE.getScenarioObject_ParentDiagram();

    /**
     * The meta object literal for the '<em><b>Contained Scenario Objects</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_OBJECT__CONTAINED_SCENARIO_OBJECTS = eINSTANCE.getScenarioObject_ContainedScenarioObjects();

    /**
     * The meta object literal for the '<em><b>Parent</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_OBJECT__PARENT = eINSTANCE.getScenarioObject_Parent();

    /**
     * The meta object literal for the '<em><b>Attributes</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_OBJECT__ATTRIBUTES = eINSTANCE.getScenarioObject_Attributes();

    /**
     * The meta object literal for the '<em><b>Links</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_OBJECT__LINKS = eINSTANCE.getScenarioObject_Links();

    /**
     * The meta object literal for the '<em><b>Outgoing Links</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_OBJECT__OUTGOING_LINKS = eINSTANCE.getScenarioObject_OutgoingLinks();

    /**
     * The meta object literal for the '<em><b>Incoming Links</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_OBJECT__INCOMING_LINKS = eINSTANCE.getScenarioObject_IncomingLinks();

    /**
     * The meta object literal for the '{@link de.uks.se.scenariodiagram.impl.ScenarioAttributeImpl <em>Scenario Attribute</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see de.uks.se.scenariodiagram.impl.ScenarioAttributeImpl
     * @see de.uks.se.scenariodiagram.impl.ScenariodiagramPackageImpl#getScenarioAttribute()
     * @generated
     */
    EClass SCENARIO_ATTRIBUTE = eINSTANCE.getScenarioAttribute();

    /**
     * The meta object literal for the '<em><b>Attribute Type</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_ATTRIBUTE__ATTRIBUTE_TYPE = eINSTANCE.getScenarioAttribute_AttributeType();

    /**
     * The meta object literal for the '<em><b>Object</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_ATTRIBUTE__OBJECT = eINSTANCE.getScenarioAttribute_Object();

    /**
     * The meta object literal for the '<em><b>Link</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_ATTRIBUTE__LINK = eINSTANCE.getScenarioAttribute_Link();

    /**
     * The meta object literal for the '<em><b>Tag</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SCENARIO_ATTRIBUTE__TAG = eINSTANCE.getScenarioAttribute_Tag();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SCENARIO_ATTRIBUTE__VALUE = eINSTANCE.getScenarioAttribute_Value();

    /**
     * The meta object literal for the '{@link de.uks.se.scenariodiagram.impl.ScenarioLinkImpl <em>Scenario Link</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see de.uks.se.scenariodiagram.impl.ScenarioLinkImpl
     * @see de.uks.se.scenariodiagram.impl.ScenariodiagramPackageImpl#getScenarioLink()
     * @generated
     */
    EClass SCENARIO_LINK = eINSTANCE.getScenarioLink();

    /**
     * The meta object literal for the '<em><b>Outgoing Reference</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_LINK__OUTGOING_REFERENCE = eINSTANCE.getScenarioLink_OutgoingReference();

    /**
     * The meta object literal for the '<em><b>Incoming Reference</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_LINK__INCOMING_REFERENCE = eINSTANCE.getScenarioLink_IncomingReference();

    /**
     * The meta object literal for the '<em><b>Attributes</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_LINK__ATTRIBUTES = eINSTANCE.getScenarioLink_Attributes();

    /**
     * The meta object literal for the '<em><b>Parent</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_LINK__PARENT = eINSTANCE.getScenarioLink_Parent();

    /**
     * The meta object literal for the '<em><b>Source</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_LINK__SOURCE = eINSTANCE.getScenarioLink_Source();

    /**
     * The meta object literal for the '<em><b>Target</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCENARIO_LINK__TARGET = eINSTANCE.getScenarioLink_Target();

  }

} //ScenariodiagramPackage
